package fse.eclipse.branchrecorder.changerecorder;

import java.io.IOException;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jgit.lib.Repository;

public class ProjectCache {
    private final IProject project;
    private final Repository repository;

    public ProjectCache(IProject project, Repository repository) {
        this.project = project;
        this.repository = repository;
    }

    public boolean hasRepository() {
        return repository != null;
    }

    public IProject getProject() {
        return project;
    }

    public String getBranchName() throws IOException {
        if (hasRepository()) {
            return repository.getBranch();
        } else {
            return null;
        }
    }

    public void refreshIProject() {
        try {
            project.refreshLocal(IResource.DEPTH_INFINITE, null);
        } catch (CoreException e) {
            e.printStackTrace();
        }
    }
}
