package fse.eclipse.mergehelper.detector;

import fse.eclipse.mergehelper.ui.dialog.ConflictDetectingDialog;

public abstract class AbstractDetector {
    public static final int STATE_NUMBER = 10;

    protected ConflictDetectingDialog dialog;

    protected abstract String getTaskName();

    protected abstract String getErrorMessage();

    protected abstract void execute();

    protected abstract void nextState();

    public void detect(ConflictDetectingDialog dialog) {
        this.dialog = dialog;

        sendMessage();

        execute();

        dialog.worked();

        nextState();
    }

    private void sendMessage() {
        String name = getTaskName();
        System.out.println(name);
        dialog.setTaskName(name);
    }

    protected void sendSubMessage(String name) {
        System.out.println(name);
        dialog.setSubTaskName(name);
    }

    protected void finish() {
        dialog.detectSuccess();
    }

    protected void error() {
        String errorMessage = getErrorMessage();
        System.err.println(errorMessage);
        dialog.detectFailed(errorMessage);
    }
}
