package fse.eclipse.mergehelper.detector;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;

import fse.eclipse.mergehelper.Activator;

public class InitWorkingDirectory extends AbstractDetector {
    private static final String TASK_NAME = "Clean Working Directory";
    private static final String ERROR_MESSAGE = "NULL";
    private static AbstractDetector instance = new InitWorkingDirectory();

    private InitWorkingDirectory() {
    }

    public static AbstractDetector getInstance() {
        return instance;
    }

    @Override
    public void execute() {
        File dir = Activator.getWorkingDir();
        if (dir.exists()) {
            try {
                FileUtils.cleanDirectory(dir);
            } catch (IOException e) {
                e.printStackTrace();
            }
        } else {
            dir.mkdirs();
        }
    }

    @Override
    protected String getTaskName() {
        return TASK_NAME;
    }

    @Override
    protected String getErrorMessage() {
        return ERROR_MESSAGE;
    }

    @Override
    protected void nextState() {
        BranchHistoryCopier.getInstance().detect(dialog);
    }
}
