package fse.eclipse.mergehelper.util;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class FileReader {

    public static List<File> getChildDirs(String path) {
        List<File> dirs = new ArrayList<>();

        File root = new File(path);
        for (File file : root.listFiles()) {
            if (file.isDirectory()) {
                dirs.add(file);
            }
        }
        return dirs;
    }

    public static List<File> getChildDirs(File dir) {
        if (dir.isDirectory()) {
            return getChildDirs(dir.getAbsolutePath());
        } else {
            return null;
        }
    }

    public static List<File> getAllXmlFiles(String path) {
        List<File> files = new ArrayList<File>();

        File dir = new File(path);
        if (dir.isFile()) {
            if (path.endsWith(".xml")) {
                files.add(dir);
            }
        } else if (dir.isDirectory()) {
            File[] children = dir.listFiles();
            for (File f : children) {
                files.addAll(getAllXmlFiles(f.getPath()));
            }
        }
        return files;
    }

    public static List<File> getAllXmlFiles(File dir) {
        if (dir.isDirectory()) {
            return getAllXmlFiles(dir.getAbsolutePath());
        } else {
            return null;
        }
    }
}
